# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import bs4 as BeautifulSoup
from urllib.parse import urlparse, urljoin
import requests

def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    download_dict = {
        "windows": "https://download.linphone.org/releases/windows/app/",
        "macos": "https://download.linphone.org/releases/macosx/app/",
        "linux": "https://download.linphone.org/releases/linux/app/?C=N;O=D",
    }
    url = download_dict[control.target_os]

    for bs_search in bs_find_all(url, "table", proxies=proxies):
        latest_bin = bs_search.findChildren(recursive=False)[4].find('a').text
        download_url = "https://download.linphone.org/releases/linux/app/" + latest_bin
        version = latest_bin.split('-', 1)[1].rsplit('.', 1)[0]


    # Downloading latest binaries
    print("Latest %s version is: %s" % (control.name, version))
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)

    # Deleting outdated binaries
    remove_outdated_binaries(latest_bin)

    
    control.set_software_version(version)
    control.save_control_to_wapt()
